package sahoo.hybridapp.example1;

import javax.servlet.annotation.WebServlet;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.URL;
import java.util.Enumeration;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.core.Application;

@WebServlet(urlPatterns = "/newServlet")
public class NewServlet extends HttpServlet {

    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
       
        response.setContentType("text/html;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            find(Application.class, out);
        } catch (Exception e) {
        }
         try {
            out.println("<html>");
            out.println("<head>");
            out.println("<title>Servlet NewServlet</title>");  
            out.println("</head>");
            out.println("<body>");
            out.println("<h1>Servlet NewServlet at " + request.getContextPath () + "</h1>");
            out.println("</body>");
            out.println("</html>");
        } finally { 
            out.close();
        }
    } 

    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    private void find(Class c, PrintWriter out) {
        try {
            String path = c.getName().replace(".", "/") + ".class";
            out.println(String.format("<h2>FIND %s, %s</h2>", c.getName(), path));

            out.println("<h3> Class loader of class:</h3>");
            Enumeration<URL> e = c.getClassLoader().getResources(path);
            while (e.hasMoreElements()) {
                out.println(e.nextElement().toExternalForm() + "<br>" );
            }

            out.println("<h3>  Context class loader:</h3>");
            e = Thread.currentThread().getContextClassLoader().getResources(path);
            while (e.hasMoreElements()) {
                out.println(e.nextElement().toExternalForm() + "<br");
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
